; start_clock_ticks(), end_clock_ticks(), clock_ticks */

IVEC    =       1CH*4

_TEXT   SEGMENT BYTE PUBLIC 'CODE'
_TEXT   ENDS

_DATA   SEGMENT WORD PUBLIC 'DATA'
        PUBLIC  _clock_ticks
_clock_ticks DD (?)
_DATA   ENDS

DGROUP  GROUP   _TEXT, _DATA

_TEXT   SEGMENT
        ASSUME  CS:DGROUP, DS:NOTHING

        PUBLIC  _start_clock_ticks, _end_clock_ticks

ISR     PROC    FAR
        ADD     WORD PTR _clock_ticks,1
        ADC     WORD PTR _clock_ticks+2,0
        DB      0EAH    ; intersegment jump
IOFS    DW      (?)
ISEG    DW      (?)
ISR     ENDP

        ASSUME  DS:DGROUP

_start_clock_ticks PROC NEAR

        SUB     AX,AX
        MOV     ES,AX
        DEC     AX
        MOV     WORD PTR _clock_ticks,AX
        MOV     WORD PTR _clock_ticks+2,AX
        CLI
        MOV     AX,ES:IVEC
        MOV     IOFS,AX
        MOV     AX,ES:(IVEC+2)
        MOV     ISEG,AX
        MOV     WORD PTR ES:IVEC,OFFSET DGROUP:ISR
        MOV     WORD PTR ES:(IVEC+2),CS
        STI
SCT2:   CMP     WORD PTR _clock_ticks,0
        JNE     SCT2
        RET

_start_clock_ticks ENDP

_end_clock_ticks PROC NEAR

        SUB     AX,AX
        MOV     ES,AX
        MOV     AX,IOFS
        CLI
        MOV     WORD PTR ES:IVEC,AX
        MOV     AX,ISEG
        MOV     WORD PTR ES:(IVEC+2),AX
        STI
        RET

_end_clock_ticks ENDP

_TEXT   ENDS
        END
