/* date_and_time() */

#include <tt.h>

static void date(struct date_and_time *p)
{
  _AH = 0x2A;
  __int__(0x21);
  p->day_of_week = _AL;
  p->day = _DL;
  p->month = _DH;
  p->year = _CX;
}

static void time(struct date_and_time *p)
{
  _AH = 0x2C;
  __int__(0x21);
  p->second = _DH;
  p->minute = _CL;
  p->hour = _CH;
}

void date_and_time(struct date_and_time *p)
{
  char day;
  date(p);
  day = p->day;
  time(p);
  date(p);
  if (p->day!=day) time(p);
}
