/* putchar(), close_putchar() */

#include <tt.h>

static unsigned i = 0;
static unsigned char buffer[512];

boolean putchar_error = FALSE;

void putchar(int c)
{
  if (!putchar_error)
  {
    buffer[i++] = c;
    if (i==sizeof(buffer))
    {
      putchar_error = write(1, buffer, i) - i;
      i = 0;
    }
  }
}

boolean close_putchar(void)
{
  if (!putchar_error && i!=0)
    putchar_error = write(1, buffer, i) - i;
  return !putchar_error;
}
