;  C Setup for bootstrap program

_TEXT   SEGMENT BYTE PUBLIC 'CODE'      ; code segment
_TEXT   ENDS
_DATA   SEGMENT WORD PUBLIC 'DATA'      ; initialized data segment
_DATA   ENDS
_BSS    SEGMENT WORD PUBLIC 'BSS'       ; uninitialized data segment
BSSBEGIN:                               ; marks beginning of _BSS
_BSS    ENDS
_BSSEND SEGMENT WORD PUBLIC 'BSSEND'    ; marks end of _BSS
BSSEND:
_BSSEND ENDS

_STACK  SEGMENT PARA STACK 'STACK'
        DW      64 DUP (?)
_STACK  ENDS

DGROUP  GROUP   _TEXT, _DATA, _BSS, _BSSEND

_DATA           SEGMENT
                EXTRN   _stack_size:WORD
                PUBLIC  ___brklvl, _heap_bottom, _heap_top

___brklvl       DW      OFFSET DGROUP:BSSEND    ; stack limit
_heap_bottom    DW      (?)
_heap_top       DW      0FFFEH
_DATA           ENDS

_TEXT   SEGMENT
        ASSUME  CS:DGROUP, DS:DGROUP

        EXTRN   _main:NEAR

BEGIN:  CLI
        MOV     AX,DGROUP
        MOV     DS,AX
        MOV     SS,AX
        MOV     SP,OFFSET DGROUP:BSSEND
        ADD     SP,_stack_size
        MOV     _heap_bottom,SP
        STI
        MOV     CX,OFFSET DGROUP:BSSEND
        MOV     DI,OFFSET DGROUP:BSSBEGIN
        SUB     CX,DI
        JZ      BEGIN3
        SUB     AX,AX
        CLD
        REP     STOSB                   ; clear _BSS segment
BEGIN3: JMP     _main

_TEXT   ENDS

        END     BEGIN
