; open_coroutine(), context_switch()

_TEXT   SEGMENT BYTE PUBLIC 'CODE'
_TEXT   ENDS

_DATA   SEGMENT WORD PUBLIC 'DATA'
        EXTRN   ___brklvl:WORD
_DATA   ENDS

DGROUP  GROUP   _TEXT,_DATA

_TEXT   SEGMENT
        ASSUME  CS:DGROUP, DS:DGROUP

        PUBLIC  _open_coroutine
        EXTRN   _malloc:NEAR

_open_coroutine PROC NEAR

        PUSH    BP
        MOV     BP,SP
        PUSH    SI
        MOV     SI,[BP+8]       ; size
        PUSH    SI
        CALL    _malloc
        POP     CX
        CMP     AX,0
        JZ      OCX
        MOV     BX,AX
        MOV     DX,[BP+4]       ; function
        MOV     [BX+SI-2],DX
        LEA     SI,[BX+SI-10]
        MOV     [BX],SI         ; initial SP
        INC     BX
        INC     BX
        MOV     [SI],BX         ; ___brklvl
OCX:    POP     SI
        POP     BP
        RET

_open_coroutine ENDP

        PUBLIC  _context_switch

_context_switch PROC NEAR

        PUSH    BP
        MOV     BP,SP
        PUSH    SI
        PUSH    DI
        PUSH    ___brklvl
        MOV     SI,[BP+4]
        XCHG    SP,[SI]
        POP     ___brklvl
        POP     DI
        POP     SI
        POP     BP
        RET

_context_switch ENDP

_TEXT   ENDS
        END
