/* pop_up() */

#define SCREEN_WIDTH 80

#pragma inline

void pop_up(unsigned row, unsigned column, unsigned height, unsigned width,
            unsigned *buffer)
{
  /* far pointer to upper left corner of rectangle */
  unsigned far *corner =
    (unsigned far *) ((equipment()&0x30)==0x30 ? 0xB0000000L : 0xB8000000L)
    +SCREEN_WIDTH*row+column;
  /* number of characters skipped when going from the end of one row
     to the beginning of the next */
  _DX = SCREEN_WIDTH-width;
  /* convert the character count to a byte count */
  _DX += _DX;
  _BX = (unsigned) buffer;
  asm les di,corner;
  asm cld;
  do
  {
    _CX = width;
    screx2:
    asm mov ax,es:[di]; /* character from screen -> AX */
    asm xchg ax,[bx]    /* exchange AX with character in buffer */
    asm stosw;          /* AX -> screen */
    asm inc bx;
    asm inc bx;
    asm loop screx2;
    asm add di,dx;
  } while (--height>0);
}
