/* pop_up_slow() */

void pop_up_slow(unsigned row, unsigned column, unsigned height,
                 unsigned width, unsigned *buffer)
{
  unsigned save_cursor = cursor();
  unsigned position = row<<8|column;
  unsigned increment = 256-width;
  do
  {
    unsigned n = width;
    do
    {
      unsigned c;
      set_cursor(position++);
      c = attribute_and_character_at_cursor();
      display_at_cursor(*buffer);
      *buffer++ = c;
    } while (--n!=0);
    position += increment;
  } while (--height!=0);
  set_cursor(save_cursor);
}
