; tabular_string_compare()


_TEXT   SEGMENT BYTE PUBLIC 'CODE'
_TEXT   ENDS

_DATA   SEGMENT WORD PUBLIC 'DATA'

        EXTRN   _comparison_table:BYTE

_DATA   ENDS

DGROUP  GROUP   _TEXT, _DATA


_TEXT   SEGMENT
        ASSUME  CS:DGROUP, DS:DGROUP

        PUBLIC  _tabular_string_compare

_tabular_string_compare PROC NEAR

        MOV     BX,SP
        PUSH    SI
        PUSH    DI
        MOV     SI,[BX+2]
        MOV     DI,[BX+4]
        MOV     BX,OFFSET DGROUP:_comparison_table - 32
TSC2:   MOV     AH,[SI]
        MOV     AL,[DI]
        OR      AX,AX           
        JZ      TSCX            ; end of both strings
        OR      AL,AL
        JZ      TSC3            ; if not end of string 2
        INC     DI              ;   move pointer to next position
        XLAT                    ;   and translate the character
TSC3:   XCHG    AL,AH
        OR      AL,AL           ; if not end of string 1
        JZ      TSC4            ;   move pointer to next position
        INC     SI              ;   and translate the character
        XLAT
TSC4:   SUB     AL,AH           ; compare translated characters
        JZ      TSC2            ; if they match, keep comparing
        CBW                     ; otherwise, sign extend difference
TSCX:   POP     DI
        POP     SI
        RET

_tabular_string_compare ENDP

_TEXT   ENDS
        END

